#ifndef _INCLUDED_PARSERGRAMMAR_H
#define _INCLUDED_PARSERGRAMMAR_H

class GrammarRule;

#define RK_NT              0
#define RK_LIT             1
#define RK_OR_RULE         2
#define RK_T_EOF           3
#define RK_TERM			   4
#define RK_IDENT           5
#define RK_T_OPENCONTEXT   6
#define RK_T_CLOSECONTEXT  7

#define IK_IDENTDEF      1
#define IK_IDENTDEFADD   2
#define IK_IDENTUSE      3
#define IK_IDENTFIELD    4

class GrammarOrRule
{   
public:
	GrammarOrRule* next;
    GrammarRule* rule;
    Ident tree_name;
};

class GrammarNonTerminal
{
public:
	GrammarNonTerminal* next;
    Ident name;
    GrammarOrRule* first;
    GrammarOrRule* recursive;
};

class GrammarTerminal
{	
public:
	GrammarTerminal(const Ident& new_name) : name(new_name) {}
	Ident name;
};

class GrammarIdent
{
public:
	int kind;
	const char *ident_class;
	GrammarTerminal* terminal;
};
	
class GrammarRule
{
public:
	GrammarRule* next;
    bool optional;
    bool sequential;
    const char *chain_symbol;
    int kind;
    union 
    {   GrammarNonTerminal* non_terminal;
    	GrammarTerminal* terminal;    
        GrammarOrRule* or_rule;
        const char *str_value;
        GrammarIdent* ident;
    } text;
    long last_fail_pos;
};


#endif // _INCLUDED_PARSERGRAMMAR_H

