// gfl.h : interface to GFL
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GFL_H__INCLUDED_)
#define AFX_GFL_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "libgfl.h"

class GFLBitmap
{
public:
	GFLBitmap() : m_gflBitmap(0), m_dib_info(0) {}
	~GFLBitmap() { clear(); }

	static bool initialized();

	void clear();
	int width();
	int height();

	bool load(const char* filename);
	void newImage(int width, int height);
	bool save(const char* filename);

	void drawImageStretch(HDC hdc, int XDest, int YDest, int nDestWidth, int nDestHeight, int XSrc, int YSrc);

	void getInterpolatedColor(double x, double y, double &r, double &g, double &b);
	void setColor(int x, int y, int r, int g, int b);

	static void init();
	static bool isImageFormat(LPCTSTR lpszPathName);

private:
	GFL_BITMAP* m_gflBitmap;
	BITMAPINFOHEADER* m_dib_info;
};

#endif // AFX_GFL_H__INCLUDED_